{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK},
     mirror, Classes, Controls, mckControls, mckObjs, mckCtrls {$ENDIF}, stega;

{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
   TStyleDialog = (sdOpenBmp,sdSaveBmp,sdOpenData,sdSaveData);

  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    MainMenu1: TKOLMainMenu;
    PaintBox1: TKOLPaintBox;
    lvContent: TKOLListView;
    Label1: TKOLLabel;
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure KOLForm1miStayOnTopMenu(Sender: PMenu; Item: Integer);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure MainMenu1miAboutMenu(Sender: PMenu; Item: Integer);
    procedure KOLForm1miLoadBitmapMenu(Sender: PMenu; Item: Integer);
    procedure MainMenu1miSaveBitmapMenu(Sender: PMenu; Item: Integer);
    procedure MainMenu1miAddFileMenu(Sender: PMenu; Item: Integer);
    procedure MainMenu1miExtractFileMenu(Sender: PMenu; Item: Integer);
    procedure KOLForm1miExitMenu(Sender: PMenu; Item: Integer);
  private
    { Private declarations }
    FStega : pStegaBMP;
    FImage : pBitMap;
  public
    { Public declarations }
    procedure PrepareDialog(st:TStyleDialog);
    procedure UpdateStatus;
    procedure LoadContainer(const FName:string);
    procedure SaveContainer(const FName:string);
    procedure AddFileInImage(const FName:string);
    procedure ExtractFileFromImage(const FName:string);
  end;

const
     progname = 'Steganography';
var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
     FStega:=NewStegaBmp;
     FImage:=NewBitmap(0,0);
end;

procedure TForm1.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
     FImage.Free;
     FStega.Free;
end;

procedure TForm1.KOLForm1miLoadBitmapMenu(Sender: PMenu; Item: Integer);
begin
      PrepareDialog(sdOpenBmp);
      If OpenSaveDialog1.Execute then LoadContainer(OpenSaveDialog1.filename);
end;

procedure TForm1.MainMenu1miSaveBitmapMenu(Sender: PMenu; Item: Integer);
begin
      PrepareDialog(sdSaveBmp);
      If OpenSaveDialog1.Execute then SaveContainer(OpenSaveDialog1.filename);
end;

procedure TForm1.MainMenu1miAddFileMenu(Sender: PMenu; Item: Integer);
begin
     PrepareDialog(sdOpenData);
     if OpenSaveDialog1.Execute then AddFileInImage(OpenSaveDialog1.FileName);
end;

procedure TForm1.MainMenu1miExtractFileMenu(Sender: PMenu; Item: Integer);
begin
     PrepareDialog(sdSaveData);
     if OpenSaveDialog1.Execute then ExtractFileFromImage(OpenSaveDialog1.FileName);
end;

procedure TForm1.KOLForm1miExitMenu(Sender: PMenu; Item: Integer);
begin
     Form.Close;
end;

procedure TForm1.KOLForm1miStayOnTopMenu(Sender: PMenu; Item: Integer);
begin
     MainMenu1.ItemChecked[miStayOnTop]:=Not MainMenu1.ItemChecked[miStayOnTop];
     Form.StayOnTop:=MainMenu1.ItemChecked[miStayOnTop];
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
begin
     FImage.StretchDraw(DC,PaintBox1.ClientRect)
end;

procedure TForm1.MainMenu1miAboutMenu(Sender: PMenu; Item: Integer);
const
   about = progname+#13#10
          +'Version 1.0 (Build 12)'+#13#10
          +'Copyright (c) 2004'+#13#10
          +'by Nasyrov Renat';
begin
     MessageBox(Form.Handle,about,'About',mb_Ok+mb_IconInformation);
end;

procedure TForm1.PrepareDialog(st: TStyleDialog);
var
   n : integer;
begin
     case st of
      sdOpenBmp : begin
               OpenSaveDialog1.OpenDialog:=true;
               OpenSaveDialog1.Filter:='Bitmap files|*.bmp|All files (*.*)|*.*';
               OpenSaveDialog1.Filename:='';
             end;
      sdSaveBmp : begin
               OpenSaveDialog1.OpenDialog:=false;
               OpenSaveDialog1.Filter:='Bitmap files|*.bmp|All files (*.*)|*.*';
               OpenSaveDialog1.Filename:=FStega.FileImage;
             end;
      sdOpenData : begin
               OpenSaveDialog1.OpenDialog:=true;
               OpenSaveDialog1.Filter:='All files (*.*)|*.*';
               OpenSaveDialog1.Filename:='';
             end;
       sdSaveData : begin
               OpenSaveDialog1.OpenDialog:=false;
               OpenSaveDialog1.Filter:='All files (*.*)|*.*';
               n:=lvContent.LVCurItem;
               OpenSaveDialog1.Filename:=lvContent.LVItems[n,0];
             end;
      end;
end;

procedure TForm1.LoadContainer(const FName: string);
var
   i,n : integer;
begin
     If Not FStega.LoadImage(FName) then
     begin
       MessageBox(Form.Handle,'File not correct',progname,mb_Ok+mb_IconError);
       Exit;
     end;

     lvContent.Clear;
     FImage.Clear;
     mainMenu1.ItemEnabled[miExtractFile]:=false;
     mainMenu1.ItemEnabled[miSavebitmap]:=false;

     if FStega.DataExist then
     begin
       for i:=0 to FStega.CountFiles-1 do
       begin
         n:=lvContent.LVItemAdd(FStega.GetFileName(i));
         lvContent.LVItems[n,1]:=int2str(FStega.GetFileSize(i));
       end;
       if FStega.CRCError
          then MessageBox(Form.Handle,'CRC Error',progname,mb_Ok+mb_IconWarning);
       mainMenu1.ItemEnabled[miExtractFile]:=true;
     end;

     FImage.LoadFromFile(FName);

     Label1.Visible:=false;
     PaintBox1.Visible:=true;
     mainMenu1.ItemEnabled[miAddFile]:=true;
     UpdateStatus;
end;

procedure TForm1.UpdateStatus;
begin
     Form.StatusText[0]:=PChar('Total: '+int2str(FStega.SizeContainer));
     Form.StatusText[1]:=PChar('Free: '+int2str(FStega.FreeSizeContainer));
     Form.StatusText[2]:=PChar('Size: '+int2str(FStega.SizeContainer-FStega.FreeSizeContainer));
end;

procedure TForm1.AddFileInImage(const FName: string);
var
    i,n:integer;
begin
     If Not FStega.AddFile(FName)
        then MessageBox(Form.Handle,'No free memory',progname,mb_Ok+mb_IconWarning)
      else begin
        n:=FStega.GetFileIndex(FName);
        i:=lvContent.LVItemAdd(FName);
        lvContent.LVItems[i,1]:=int2str(FStega.GetFileSize(n));

        mainMenu1.ItemEnabled[miSaveBitmap]:=true;
        UpdateStatus;
      end;
end;

procedure TForm1.SaveContainer(const FName: string);
begin
     FStega.SaveImage(FName);
     FImage.Clear;
     FImage.LoadFromFile(FName);
     MessageBox(Form.Handle,'Done!',progname,mb_Ok+mb_IconInformation);
end;

procedure TForm1.ExtractFileFromImage(const FName: string);
var
   n : integer;
begin
     n:=lvContent.LVCurItem;
     n:=FStega.GetFileIndex(lvContent.LVItems[n,0]);
     FStega.ExtractFile(n,FName);
     MessageBox(Form.Handle,'Done!',progname,mb_Ok+mb_IconInformation);
end;

end.


