unit binary;

interface

type
    TBitsArray = array[0..7] of byte;
    TDoubleWordArray = array[0..3] of byte;

    function z4BytesToInt(a:TDoubleWordArray):integer;

    function BinToHex(a:TBitsArray):byte;
    procedure HexToBin(x:byte;var a:TBitsArray);

    function SetBit(SByte: byte; num: byte): byte;
    function ResetBit(SByte: byte; num: byte): byte;

implementation

function ResetBit(SByte, num: byte): byte;
begin
     Result := SByte and not (1 shl num);
end;

function SetBit(SByte, num: byte): byte;
begin
     Result := SByte or (1 shl num);
end;

procedure HexToBin(x: byte; var a: TBitsArray);
var
   bit,i  : byte;
begin
  for i:=7 downto 0 do
  begin
    if (X and (1 shl i))<>0 then bit:=1 else bit:=0;
    a[i]:=bit;
  end;
end;

function BinToHex(a:TBitsArray):byte;
var
   i   : integer;
   bit : byte;
begin
     Result:=0;
     for i:=7 downto 0 do
     begin
       bit:=a[i];
       if (bit and (1 shl 7)) <> 0 then bit:=1;
       Result:=Result or bit;
       if i<>0 then Result:=Result shl 1;
     end;
end;

function z4BytesToInt(a: TDoubleWordArray): integer;
var
   i : integer;
begin
    Result:=0;
    for i:=3 downto 0 do
    begin
      Result:=Result or a[i];
      if i<>0 then Result:=Result shl 8;
    end;
end;

end.
